package tenet.protocol.datalink.sfdatalink;

import java.util.ArrayList;

import tenet.core.Simulator;
import tenet.node.l2switch.L2Switch;
import tenet.protocol.datalink.FrameParamStruct;
import tenet.protocol.datalink.IDataLinkLayer;
import tenet.protocol.datalink.MediumAddress;
import tenet.protocol.datalink.SEther.SimpleEthernetDatalink;
import tenet.protocol.physics.Link;

/**
* 㽻ҪʹõľдתIDatalinkLayer
* һ˵ֻL2SwitchʹõStoreForwardingDatalink
* ͬʱStoreForwardingDatalink󶨵NodeһL2Switch
*/
public class StoreForwardingDatalink extends SimpleEthernetDatalink {

	protected final static boolean debug=false;

    /**
     * Ҫת֡Ķ
     */
	public ArrayList<FrameParamStruct> m_send_queue;

	public StoreForwardingDatalink(MediumAddress m_mac) {
		super(m_mac);
		m_send_queue = new ArrayList<FrameParamStruct>();
	}

	/**
	* ·ϿʱеĴ
	*/
	@Override
	protected void linkDown() {
		super.linkDown(); //ø̣ʹ״̬ıźŴﵽضԶ
		//жϵĵȴ״̬յжϵ߼
		this.resetInterrupt(Link.INT_LINK_READ_ERROR);
		this.resetInterrupt(Link.INT_LINK_READ_OK);
		this.resetInterrupt(INT_RECEIVE_LINKDOWN);
		this.resetInterrupt(INT_RECEIVE_COLLISION);
		this.resetInterrupt(Link.INT_LINK_SEND_ERROR);
		this.resetInterrupt(Link.INT_LINK_SEND_OK);
		this.resetInterrupt(INT_SEND_LINKDOWN);
		this.resetInterrupt(INT_SEND_COLLISION);
		this.m_send_queue.clear();//еȴ͵֡Ա
	}

	/**
	* ·Ϊ״̬ʱеĴ
	*/
	@Override
	protected void linkUp() {
		super.linkUp();//ø̣ʹ״̬ıźŴﵽضԶ
		this.waitReceiveSignal();//ȴнҪжź
	}

	//Щ̶SimpleEthernetDatalink.interruptHandlerеõĺӦжźſȥԭ鿴
	
	/**
	 * ִ֡
	 */
	@Override
	protected void onReadError(FrameParamStruct param) {
	}

	/**
	 * ֡ȷ
	 */
	@Override
	protected void onReadOK(FrameParamStruct param) {
	}

	/**
	 * ֡У
	 */
	@Override
	protected void onReadOKwithCheckError(FrameParamStruct param) {
	}

	/**
	 * ֽճͻжϵ
	 */
	@Override
	protected void onReceiveRequireCollision(FrameParamStruct param) {
	}

	/**
	 * ַǽ״̬յжϵ
	 */
	@Override
	protected void onReceiveRequireLinkDown(FrameParamStruct param) {
	}

	/**
	 * ִ֡
	 */
	@Override
	protected void onSendError(FrameParamStruct param) {
	}

	/**
	 * ɹ֡
	 */
	@Override
	protected void onSendOK(FrameParamStruct param) {
	}

	/**
	 * ַͳͻжϵ
	 */
	@Override
	protected void onTransmitRequireCollision(FrameParamStruct param) {
	}

	/**
	 * ַǽ״̬͵жϵ
	 */
	@Override
	protected void onTransmitRequireLinkDown(FrameParamStruct param) {
	}
}
